import { Vnode } from 'hslayout';
export interface SelectorDesc {
    items: string[];
    itemCss?: string[];
    defaultItem?: string | number;
    clicked: (item: string) => void;
    mouseDown?: (item: string) => void;
    mouseUp?: (item: string) => void;
}
export interface SelectableDesc {
    title: string;
    isSelected: boolean;
    css?: string;
    style?: string;
    clicked?: (item: string) => void;
    mouseDown?: (item: string) => void;
    mouseUp?: (item: string) => void;
}
export declare type selectionModel = (items: SelectableDesc[], title: string) => SelectableDesc;
export declare function oneOfItems(items: SelectableDesc[], title: string): SelectableDesc;
export declare function anyItems(items: SelectableDesc[], title: string): SelectableDesc;
export interface SelectorState {
    updateModel: selectionModel;
    items: SelectableDesc[];
    events: (e: any) => void;
    itemClicked?: (item: string) => string;
    defaultItem?: string;
}
export declare abstract class Selector {
    static updateItems(node: Vnode): void;
    static init(node: Vnode, model?: typeof oneOfItems): void;
    oninit(node: Vnode): void;
    onupdate(node: Vnode): void;
    protected static ensureSelected(node: Vnode): void;
    protected static renderItem(node: Vnode, i: number): any;
    abstract view(node: Vnode): Vnode;
}
export declare function renderSelectable(d: SelectableDesc): any;
